#!/usr/bin/ruby
# coding:ISO-8859-1
#-------------------------------------------------------------
# Cave: Internet-Explorer muss OHNE jegliche Leisten starten !
# (sonst stimmt Anzahl der Tabs nicht)
#-------------------------------------------------------------

require_relative '../Common/common'
#{{{{Vorbelegungen und globale Variablen
screenplay=false  # Drehbuch (wird via Commandline belegt)
#}}}}
  def navigate(ie,wsh,screenplay)#{{{{
    #-------------------------------------------------------------------------------------------------
    # Dateiformat:
    #
    # #.+       <= Kommentar
    # ^\s+$     <= Leerzeilen
    # Eintraege der Art
    #   <Zeichenfolge> <optional: Wiederholungszahl>
    #   navigate <URL>
    #   include <Include-Datei, optional rekursiv>
    #   exit
    #-------------------------------------------------------------------------------------------------
    begin
      lineArr=readFileRecursively(screenplay)
      #-----------------------------------------------------------------------------------------------
      # Drehbuch abarbeiten
      #-----------------------------------------------------------------------------------------------
      lineArr.each{ |line|
        if(line.match(/^#/))
          puts(line)
          next 
        end
        line.match(/^\s*$/) && next 
        #---------------------------------------------------------------------------------------------
        # Zeile besteht aus 1 oder 2 durch Whitespace getrennten Eintraegen
        #---------------------------------------------------------------------------------------------
        if(line.match(/^(\S+)\s+(\S+)$/))
          key=$1.to_s
          value=$2.to_s
        elsif(line.match(/^(\S+)\s*$/))
          key=$1.to_s
          value="1"
        else
          die("navigate: Invalid line #{line}")
        end 
        if(key.downcase == "navigate")
          target=value
          puts("navigating ...")
          ie.navigate(target)
        elsif(key.downcase == "sleep")
          duration=value.to_i
          puts("sleeping #{duration} sec.")
          sleep(duration)
        elsif(key.downcase == "space")
          key=' '
          num=value.to_i
          sendKeys(wsh,key,num)
        elsif(key.downcase == "%space")
          key='% '
          num=value.to_i
          sendKeys(wsh,key,num)
        elsif(key.downcase == "exit")
          puts("exiting ...")
          exit 
        else
          num=value.to_i
          sendKeys(wsh,key,num)
        end
      }
    rescue => exception
      die("navigate: #{exception.message}")
    end
  end#}}}}
#{{{{Commandline-Options
options=GetoptLong.new(
  ['--help', '-h', GetoptLong::NO_ARGUMENT],
  ['--file','-f',GetoptLong::REQUIRED_ARGUMENT]
)
options.each do |opt,arg|
  case opt
    when '--help'
      puts("Usage: ruby ie.rb [-h] [-f <Drehbuch>]")
      exit
    when '--file'
      screenplay=arg
  end
end
#}}}}
#{{{{ Hauptverarbeitung
begin
  unless(screenplay)
    die("Infile missing on command-line. Please specify infile with option '-f <infile>'")
  end
  ie,ieId,wsh=startActivateIE()
  navigate(ie,wsh,screenplay)
rescue => exception
  die(exception.message)
end
#}}}}
